diff --git a/gcc/analyzer/region-model.h b/gcc/analyzer/region-model.h
index d0ab2c12829..c066cb507ae 100644
--- a/gcc/analyzer/region-model.h
+++ b/gcc/analyzer/region-model.h
@@ -18,270 +18,3035 @@ You should have received a copy of the GNU General Public License
 along with GCC; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
-#ifndef GCC_ANALYZER_REGION_MODEL_H
-#define GCC_ANALYZER_REGION_MODEL_H
+#ifndef GCC_ANALYZER_REGION_MODEL_2_H
+#define GCC_ANALYZER_REGION_MODEL_2_H
+
+#include "analyzer/uniq-manager.h" // FIXME
+#include "analyzer/store2.h" // FIXME
+#include "analyzer/program-point.h" // FIXME
+
+#define WIDENING 1
 
 /* Implementation of the region-based ternary model described in:
      "A Memory Model for Static Analysis of C Programs"
       (Zhongxing Xu, Ted Kremenek, and Jian Zhang)
      http://lcs.ios.ac.cn/~xuzb/canalyze/memmodel.pdf  */
 
-using namespace ana;
 
-namespace inchash
+/* FIXME:
+   This prototype has an alternate implementation of region_model.
+   Idea:
+   - no region_id or svalue_id, just pointers.
+   - regions are shared throughout the analysis, via a region_manager.
+   - should svalues also be shared?  Probably
+   - regions and values don't have state; region_model2 instances do
+     (though potentially we want to use the regions to store information
+     about the shared region structure e.g. subregions of map_region)
+   - no canonicalization or ID remapping should be needed
+   - uniqueness of regions: comparison by pointer rather than by fields
+     (but maybe we need to keep the compare_fields for implementing the
+     uniquifying?)
+   - not yet sure if we need validation
+   - the concept of what the "current stack" is needs to move from the
+     regions to the region_model2 (maybe a region *m_current_frame)
+   - do we still need region cloning?
+   - should there still be a root_region?  or should those things go in the
+     ext_state (or something owned by ext_state: region_model2_manager)
+   Hopefully this is a huge simplification, and (I hope) avoids lots of heap
+   churn as states are copied.
+
+   Other ideas:
+   - region subclasses no longer represent internal structure, but instead
+     represent how the regions are reached.  So e.g. a global
+     "struct coord c;" is now a decl_region, rather than a struct_region.
+
+   TODO:
+   - some selftests depend on bit sizes of types, hopefully via the TYPE_SIZE
+     macros (see e.g. INT_TYPE_SIZE in defaults.h).  Remember to test on
+     some other targets.  Similarly, big-endian vs little-endian.  */
+
+using namespace ana;
+
+namespace inchash
+{
+  extern void add_path_var (path_var pv, hash &hstate);
+} // namespace inchash
+
+
+namespace ana {
+
+/* A hash traits class that uses member functions to implement
+   the various required ops.  */
+
+template <typename Type>
+struct member_function_hash_traits : public typed_noop_remove<Type>
+{
+  typedef Type value_type;
+  typedef Type compare_type;
+  static inline hashval_t hash (value_type v) { return v.hash (); }
+  static inline bool equal (const value_type &existing,
+			    const value_type &candidate)
+  {
+    return existing == candidate;
+  }
+  static inline void mark_deleted (Type &t) { t.mark_deleted (); }
+  static inline void mark_empty (Type &t) { t.mark_empty (); }
+  static inline bool is_deleted (Type t) { return t.is_deleted (); }
+  static inline bool is_empty (Type t) { return t.is_empty (); }
+};
+
+/* A region_model2 is effectively a graph of regions and symbolic values.
+   FIXME: we're eliminating IDs in this prototype.
+   We store per-model IDs rather than pointers to make it easier to clone
+   and to compare graphs.  */
+
+/* Various operations delete information from a region_model2.
+
+   This struct tracks how many of each kind of entity were purged (e.g.
+   for selftests, and for debugging).  */
+
+struct purge_stats2
+{
+  purge_stats2 ()
+  : m_num_svalues (0),
+    m_num_regions (0),
+    m_num_equiv_classes (0),
+    m_num_constraints (0),
+    m_num_client_items (0)
+  {}
+
+  int m_num_svalues;
+  int m_num_regions;
+  int m_num_equiv_classes;
+  int m_num_constraints;
+  int m_num_client_items;
+};
+
+/* A measurement of the complexity of an svalue2 or region2, so that
+   we can avoid these tree-like structures growing without bounds and
+   thus leading to infinite chains of analysis.  */
+
+struct complexity
+{
+  complexity (unsigned num_nodes, unsigned max_depth)
+  : m_num_nodes (num_nodes), m_max_depth (max_depth)
+  {}
+
+  complexity (const region2 *reg);
+  complexity (const svalue2 *sval);
+  static complexity from_pair (const complexity &c1, const complexity &c2);
+
+  /* The total number of svalue2s and region2s in the tree of this
+     entity, including the entity itself.  */
+  unsigned m_num_nodes;
+
+  /* The maximum depth of the tree of this entity, including the
+     entity itself.  */
+  unsigned m_max_depth;
+};
+
+class visitor
+{
+public:
+  virtual void visit_region_svalue2 (const region_svalue2 *) {}
+  virtual void visit_constant_svalue2 (const constant_svalue2 *) {}
+  virtual void visit_unknown_svalue2 (const unknown_svalue2 *) {}
+  virtual void visit_poisoned_svalue2 (const poisoned_svalue2 *) {}
+  virtual void visit_setjmp_svalue2 (const setjmp_svalue2 *) {}
+  virtual void visit_initial_svalue2 (const initial_svalue2 *) {}
+  virtual void visit_unaryop_svalue2 (const unaryop_svalue2 *) {}
+  virtual void visit_binop_svalue2 (const binop_svalue2 *) {}
+  virtual void visit_sub_svalue2 (const sub_svalue2 *) {}
+  virtual void visit_unmergeable_svalue2 (const unmergeable_svalue2 *) {}
+  virtual void visit_placeholder_svalue2 (const placeholder_svalue2 *) {}
+  virtual void visit_widening_svalue2 (const widening_svalue2 *) {}
+  virtual void visit_compound_svalue2 (const compound_svalue2 *) {}
+  virtual void visit_conjured_svalue2 (const conjured_svalue2 *) {}
+
+  virtual void visit_region (const region2 *) {}
+};
+
+/* svalue and its subclasses.
+
+   The class hierarchy looks like this (using indentation to show
+   inheritance, and with kinds shown for the concrete subclasses):
+
+   svalue2
+     region_svalue2 (SK_REGION): a pointer to a region2
+     constant_svalue2 (SK_CONSTANT): a constant
+     unknown_svalue2 (SK_UNKNOWN): an unknowable value
+     poisoned_svalue2 (SK_POISONED): a unusable value (undefined)
+     setjmp_svalue2 (SK_SETJMP): a setjmp/longjmp buffer
+     initial2_svalue2 (SK_INITIAL): the initial value of a region2
+     unaryop_svalue2 (SK_UNARYOP): unary operation on another svalue2
+     binop_svalue2 (SK_BINOP): binary operation on two svalue2s
+     sub_svalue2 (SK_SUB): the result of accessing a subregion
+     unmergeable_svalue2 (SK_UNMERGEABLE): a value that is so interesting
+       from a control-flow perspective that it can inhibit state-merging
+     placeholder_svalue2 (SK_PLACEHOLDER): for use in selftests.
+     widening_svalue2 (SK_WIDENING): a merger of two svalues (possibly
+       in an iteration).
+     compound_svalue2 (SK_COMPOUND): a mapping of bit-ranges to svalues
+     conjured_svalue2 (SK_CONJURED): a value arising from a stmt.  */
+
+/* An abstract base class representing a value held by a region of memory.  */
+
+class svalue2
+{
+public:
+  /* An enum for discriminating between the different concrete subclasses
+   of svalue.  */
+  enum kind
+  {
+   SK_REGION,
+   SK_CONSTANT,
+   SK_UNKNOWN,
+   SK_POISONED,
+   SK_SETJMP,
+   SK_INITIAL,
+   SK_UNARYOP,
+   SK_BINOP,
+   SK_SUB,
+   SK_UNMERGEABLE,
+   SK_PLACEHOLDER,
+   SK_WIDENING,
+   SK_COMPOUND,
+   SK_CONJURED
+  };
+
+  virtual ~svalue2 () {}
+
+#if 0
+  bool operator== (const svalue2 &other) const;
+  bool operator!= (const svalue2 &other) const { return !(*this == other); }
+#endif
+
+  tree get_type () const { return m_type; }
+
+  virtual enum kind get_kind () const = 0;
+
+  void print (const region_model2 &model,
+	      pretty_printer *pp) const;
+
+#if 0
+  virtual void dump_dot_to_pp (const region_model2 &model,
+			       pretty_printer *pp) const;
+#endif
+
+  virtual void dump_to_pp (pretty_printer *pp, bool simple) const = 0;
+  void dump (bool simple=true) const;
+  label_text get_desc (bool simple=true) const;
+
+  virtual const region_svalue2 *
+  dyn_cast_region_svalue2 () const { return NULL; }
+  virtual const constant_svalue2 *
+  dyn_cast_constant_svalue2 () const { return NULL; }
+  virtual const poisoned_svalue2 *
+  dyn_cast_poisoned_svalue2 () const { return NULL; }
+  virtual const setjmp_svalue2 *
+  dyn_cast_setjmp_svalue2 () const { return NULL; }
+  virtual const initial_svalue2 *
+  dyn_cast_initial_svalue2 () const { return NULL; }
+  virtual const unaryop_svalue2 *
+  dyn_cast_unaryop_svalue2 () const { return NULL; }
+  virtual const binop_svalue2 *
+  dyn_cast_binop_svalue2 () const { return NULL; }
+  virtual const sub_svalue2 *
+  dyn_cast_sub_svalue2 () const { return NULL; }
+  virtual const unmergeable_svalue2 *
+  dyn_cast_unmergeable_svalue2 () const { return NULL; }
+  virtual const widening_svalue2 *
+  dyn_cast_widening_svalue2 () const { return NULL; }
+  virtual const compound_svalue2 *
+  dyn_cast_compound_svalue2 () const { return NULL; }
+  virtual const conjured_svalue2 *
+  dyn_cast_conjured_svalue2 () const { return NULL; }
+
+  tree maybe_get_constant () const;
+  const svalue2 *maybe_undo_cast () const;
+  const svalue2 *unwrap_any_unmergeable () const;
+
+  const svalue2 *can_merge_p (const svalue2 *other,
+			      region_model2_manager *mgr,
+			      model2_merger *merger) const;
+
+  const complexity &get_complexity () const { return m_complexity; }
+
+  virtual void accept (visitor *v) const  = 0;
+
+  bool live_p (const svalue2_set &live_svalues,
+	       const region_model2 *model) const;
+  virtual bool implicitly_live_p (const svalue2_set &live_svalues,
+				  const region_model2 *model) const;
+
+ protected:
+  svalue2 (complexity c, tree type)
+  : m_complexity (c), m_type (type)
+  {}
+
+ private:
+  complexity m_complexity;
+  tree m_type;
+};
+
+/* Concrete subclass of svalue2 representing a pointer value that points to
+   a known region  */
+
+class region_svalue2 : public svalue2
+{
+public:
+  region_svalue2 (tree type, const region2 *reg)
+  : svalue2 (complexity (reg), type),
+    m_reg (reg)
+  {
+    gcc_assert (m_reg != NULL);
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_REGION; }
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const region_svalue2 *
+  dyn_cast_region_svalue2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  const region2 * get_pointee () const { return m_reg; }
+
+#if 0
+  static void merge_values (const region_svalue2 &region_sval_a,
+			    const region_svalue2 &region_sval_b,
+			    svalue2_id *merged_sid,
+			    tree type,
+			    model_merger *merger);
+#endif
+
+  static tristate eval_condition (const region_svalue2 *lhs_ptr,
+				  enum tree_code op,
+				  const region_svalue2 *rhs_ptr);
+
+ private:
+  const region2 *m_reg;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const region_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_REGION;
+}
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing a specific constant value.  */
+
+class constant_svalue2 : public svalue2
+{
+public:
+  constant_svalue2 (tree cst_expr)
+  : svalue2 (complexity (1, 1), TREE_TYPE (cst_expr)), m_cst_expr (cst_expr)
+  {
+    gcc_assert (cst_expr);
+    gcc_assert (CONSTANT_CLASS_P (cst_expr));
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_CONSTANT; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const constant_svalue2 *
+  dyn_cast_constant_svalue2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  bool implicitly_live_p (const svalue2_set &,
+			  const region_model2 *) const FINAL OVERRIDE;
+
+  tree get_constant () const { return m_cst_expr; }
+
+#if 0
+  static void merge_values (const constant_svalue2 &cst_sval_a,
+			    const constant_svalue2 &cst_sval_b,
+			    svalue2_id *merged_sid,
+			    model_merger *merger);
+#endif
+
+  static tristate eval_condition (const constant_svalue2 *lhs,
+				  enum tree_code op,
+				  const constant_svalue2 *rhs);
+
+ private:
+  tree m_cst_expr;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const constant_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_CONSTANT;
+}
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing an unknowable value, the bottom
+   value when thinking of svalue2s as a lattice.
+   This is a singleton (w.r.t. its manager): there is a single unknown_svalue2
+   per type.  Self-comparisons of such instances yield "unknown".  */
+
+class unknown_svalue2 : public svalue2
+{
+public:
+  unknown_svalue2 (tree type)
+  : svalue2 (complexity (1, 1), type)
+  {}
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_UNKNOWN; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+};
+
+#if 0
+/* An enum describing a particular kind of "poisoned" value.  */
+
+enum poison_kind
+{
+  /* For use to describe uninitialized memory.  */
+  POISON_KIND_UNINIT,
+
+  /* For use to describe freed memory.  */
+  POISON_KIND_FREED,
+
+  /* For use on pointers to regions within popped stack frames.  */
+  POISON_KIND_POPPED_STACK
+};
+#endif
+
+extern const char *poison_kind_to_str (enum poison_kind);
+
+/* Concrete subclass of svalue2 representing a value that should not
+   be used (e.g. uninitialized memory, freed memory).  */
+
+class poisoned_svalue2 : public svalue2
+{
+public:
+  /* A support class for uniquifying instances of poisoned_svalue2.  */
+  struct key_t
+  {
+    key_t (enum poison_kind kind, tree type)
+    : m_kind (kind), m_type (type)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_int (m_kind);
+      hstate.add_ptr (m_type);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_kind == other.m_kind && m_type == other.m_type);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    enum poison_kind m_kind;
+    tree m_type;
+  };
+
+  poisoned_svalue2 (enum poison_kind kind, tree type)
+  : svalue2 (complexity (1, 1), type), m_kind (kind) {}
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_POISONED; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const poisoned_svalue2 *
+  dyn_cast_poisoned_svalue2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  enum poison_kind get_poison_kind () const { return m_kind; }
+
+ private:
+  enum poison_kind m_kind;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const poisoned_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_POISONED;
+}
+
+template <> struct default_hash_traits<poisoned_svalue2::key_t>
+: public member_function_hash_traits<poisoned_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing buffers for setjmp/sigsetjmp,
+   so that longjmp/siglongjmp can potentially "return" to an entirely
+   different function.  */
+
+class setjmp_svalue2 : public svalue2
+{
+public:
+  /* A support class for uniquifying instances of poisoned_svalue2.  */
+  struct key_t
+  {
+    key_t (const setjmp_record &record, tree type)
+    : m_record (record), m_type (type)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      m_record.add_to_hash (&hstate);
+      hstate.add_ptr (m_type);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_record == other.m_record && m_type == other.m_type);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    setjmp_record m_record;
+    tree m_type;
+  };
+
+  setjmp_svalue2 (const setjmp_record &setjmp_record,
+		  tree type)
+  : svalue2 (complexity (1, 1), type), m_setjmp_record (setjmp_record)
+  {}
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_SETJMP; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const setjmp_svalue2 *
+  dyn_cast_setjmp_svalue2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  int get_enode_index () const;
+
+  const setjmp_record &get_setjmp_record () const { return m_setjmp_record; }
+
+ private:
+  setjmp_record m_setjmp_record;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const setjmp_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_SETJMP;
+}
+
+template <> struct default_hash_traits<setjmp_svalue2::key_t>
+: public member_function_hash_traits<setjmp_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing the initial value of a
+   specific region.
+
+   FIXME: trying this approach:
+   This represents the initial value at the start of the analysis path,
+   as opposed to the first time the region is accessed during the path.
+   Hence as soon as we have a call to an unknown function, all previously
+   unmodelled globals become implicitly "unknown" rathen than "initial".  */
+
+class initial_svalue2 : public svalue2
+{
+public:
+  initial_svalue2 (tree type, const region2 *reg)
+  : svalue2 (complexity (reg), type), m_reg (reg)
+  {
+    gcc_assert (m_reg != NULL);
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_INITIAL; }
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const initial_svalue2 *
+  dyn_cast_initial_svalue2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  bool implicitly_live_p (const svalue2_set &,
+			  const region_model2 *) const FINAL OVERRIDE;
+
+  const region2 * get_region () const { return m_reg; }
+
+#if 0
+  static void merge_values (const initial_svalue2 &region_sval_a,
+			    const initial_svalue2 &region_sval_b,
+			    svalue2_id *merged_sid,
+			    tree type,
+			    model_merger *merger);
+#endif
+
+ private:
+  const region2 *m_reg;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const initial_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_INITIAL;
+}
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing a unary operation on
+   another svalue2s (e.g. a cast).  */
+
+class unaryop_svalue2 : public svalue2
+{
+public:
+  /* A support class for uniquifying instances of unaryop_svalue2.  */
+  struct key_t
+  {
+    key_t (tree type, enum tree_code op, const svalue2 *arg)
+    : m_type (type), m_op (op), m_arg (arg)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_type);
+      hstate.add_int (m_op);
+      hstate.add_ptr (m_arg);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_type == other.m_type
+	      && m_op == other.m_op
+	      && m_arg == other.m_arg);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    tree m_type;
+    enum tree_code m_op;
+    const svalue2 *m_arg;
+  };
+
+  unaryop_svalue2 (tree type, enum tree_code op, const svalue2 *arg)
+  : svalue2 (complexity (arg), type), m_op (op), m_arg (arg)
+  {
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_UNARYOP; }
+  const unaryop_svalue2 *
+  dyn_cast_unaryop_svalue2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  bool implicitly_live_p (const svalue2_set &,
+			  const region_model2 *) const FINAL OVERRIDE;
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+
+  enum tree_code get_op () const { return m_op; }
+  const svalue2 *get_arg () const { return m_arg; }
+
+ private:
+  enum tree_code m_op;
+  const svalue2 *m_arg;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const unaryop_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_UNARYOP;
+}
+
+template <> struct default_hash_traits<unaryop_svalue2::key_t>
+: public member_function_hash_traits<unaryop_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing a binary operation of
+   two svalue2s.  */
+
+class binop_svalue2 : public svalue2
+{
+public:
+  /* A support class for uniquifying instances of binop_svalue2.  */
+  struct key_t
+  {
+    key_t (tree type, enum tree_code op,
+	   const svalue2 *arg0, const svalue2 *arg1)
+    : m_type (type), m_op (op), m_arg0 (arg0), m_arg1 (arg1)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_type);
+      hstate.add_int (m_op);
+      hstate.add_ptr (m_arg0);
+      hstate.add_ptr (m_arg1);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_type == other.m_type
+	      && m_op == other.m_op
+	      && m_arg0 == other.m_arg0
+	      && m_arg1 == other.m_arg1);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    tree m_type;
+    enum tree_code m_op;
+    const svalue2 *m_arg0;
+    const svalue2 *m_arg1;
+  };
+
+  binop_svalue2 (tree type, enum tree_code op,
+		 const svalue2 *arg0, const svalue2 *arg1)
+  : svalue2 (complexity::from_pair (arg0->get_complexity (),
+				    arg1->get_complexity ()),
+	     type),
+    m_op (op), m_arg0 (arg0), m_arg1 (arg1)
+  {
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_BINOP; }
+  virtual const binop_svalue2 *dyn_cast_binop_svalue2 () const { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  bool implicitly_live_p (const svalue2_set &,
+			  const region_model2 *) const FINAL OVERRIDE;
+
+  enum tree_code get_op () const { return m_op; }
+  const svalue2 *get_arg0 () const { return m_arg0; }
+  const svalue2 *get_arg1 () const { return m_arg1; }
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+#if 0
+  const binop_svalue2 *
+  dyn_cast_binop_svalue2 () const FINAL OVERRIDE { return this; }
+#endif
+
+ private:
+  enum tree_code m_op;
+  const svalue2 *m_arg0;
+  const svalue2 *m_arg1;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const binop_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_BINOP;
+}
+
+template <> struct default_hash_traits<binop_svalue2::key_t>
+: public member_function_hash_traits<binop_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing the result of accessing a subregion
+   of another svalue2 (the value of a component/field of a struct, or an element
+   from an array).
+   FIXME: do we want to split this into two different classes for that?  */
+
+class sub_svalue2 : public svalue2
+{
+public:
+  /* A support class for uniquifying instances of sub_svalue2.  */
+  struct key_t
+  {
+    key_t (tree type, const svalue2 *parent_svalue, const region2 *subregion)
+    : m_type (type), m_parent_svalue (parent_svalue), m_subregion (subregion)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_type);
+      hstate.add_ptr (m_parent_svalue);
+      hstate.add_ptr (m_subregion);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_type == other.m_type
+	      && m_parent_svalue == other.m_parent_svalue
+	      && m_subregion == other.m_subregion);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    tree m_type;
+    const svalue2 *m_parent_svalue;
+    const region2 *m_subregion;
+  };
+  sub_svalue2 (tree type, const svalue2 *parent_svalue,
+	       const region2 *subregion);
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_SUB; }
+  const sub_svalue2 *dyn_cast_sub_svalue2 () const FINAL OVERRIDE
+  {
+    return this;
+  }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  bool implicitly_live_p (const svalue2_set &,
+			  const region_model2 *) const FINAL OVERRIDE;
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const svalue2 *get_parent () const { return m_parent_svalue; }
+  const region2 *get_subregion () const { return m_subregion; }
+
+ private:
+  const svalue2 *m_parent_svalue;
+  const region2 *m_subregion;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const sub_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_SUB;
+}
+
+template <> struct default_hash_traits<sub_svalue2::key_t>
+: public member_function_hash_traits<sub_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
+namespace ana {
+
+/* Concrete subclass of svalue2: decorate another svalue2,
+   so that the resulting svalue2 can be identified as being
+   "interesting to control flow".
+   For example, consider the return value from setjmp.  We
+   don't want to merge states in which the result is 0 with
+   those in which the result is non-zero.  By using an
+   unmergeable_svalue2 for the result, we can inhibit such merges
+   and have separate exploded nodes for those states, keeping
+   the first and second returns from setjmp distinct in the exploded
+   graph.
+   FIXME: possibly rename to "significant_svalue2"?
+   FIXME: possibly use this to capture "significant" conditions in
+   control flow, and to use this to tweak descriptions of conditions
+   in paths.  Specifically, could this be used by
+     start_cfg_edge_event::maybe_describe_condition
+   to emit things like
+     following 'true' branch (when value returned from 'setjmp' is non-zero)
+   or somesuch.  */
+
+class unmergeable_svalue2 : public svalue2
+{
+public:
+  unmergeable_svalue2 (const svalue2 *arg)
+  : svalue2 (complexity (arg), arg->get_type ()), m_arg (arg)
+  {
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_UNMERGEABLE; }
+  const unmergeable_svalue2 *
+  dyn_cast_unmergeable_svalue2 () const FINAL OVERRIDE { return this; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  bool implicitly_live_p (const svalue2_set &,
+			  const region_model2 *) const FINAL OVERRIDE;
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const svalue2 *get_arg () const { return m_arg; }
+
+ private:
+  const svalue2 *m_arg;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const unmergeable_svalue2 *>::test (const svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_UNMERGEABLE;
+}
+
+namespace ana {
+
+/* Concrete subclass of svalue2 for use in selftests, where
+   we want a specific but unknown svalue2.
+   Unlike other svalue2 subclasses these aren't managed by
+   region_model2_manager.  */
+
+class placeholder_svalue2 : public svalue2
+{
+public:
+  placeholder_svalue2 (tree type, const char *name)
+  : svalue2 (complexity (1, 1), type), m_name (name)
+  {
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_PLACEHOLDER; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+#if 0
+  binop_svalue2 *dyn_cast_placeholder_svalue2 () FINAL OVERRIDE { return this; }
+#endif
+
+ private:
+  const char *m_name;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <placeholder_svalue2 *>::test (svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_PLACEHOLDER;
+}
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing a "widening" seen when merging
+   states, widening from a base value to {base value, iter value} and thus
+   representing a possible fixed point in an iteration from the base to
+   +ve infinity, or -ve infinity, and thus useful for representing a value
+   within a loop.
+   We also need to capture the program_point at which the merger happens,
+   so that distinguish between different iterators, and thus handle
+   nested loops.
+
+   FIXME: firm this up; clarify the above.  */
+
+class widening_svalue2 : public svalue2
+{
+public:
+  /* A support class for uniquifying instances of widening_svalue2.  */
+  struct key_t
+  {
+#if 0
+    struct hash_map_traits
+    {
+      typedef key_t key_type;
+      typedef const widening_svalue2 *value_type;
+      typedef const widening_svalue2 *compare_type;
+
+      static inline hashval_t hash (const key_type &k)
+      {
+	gcc_assert (k != NULL);
+	gcc_assert (k != reinterpret_cast<key_type> (1));
+	return k->hash ();
+      }
+      static inline bool equal_keys (const key_type &k1, const key_type &k2)
+      {
+	gcc_assert (k1 != NULL);
+	gcc_assert (k2 != NULL);
+	gcc_assert (k1 != reinterpret_cast<key_type> (1));
+	gcc_assert (k2 != reinterpret_cast<key_type> (1));
+	if (k1 && k2)
+	  return *k1 == *k2;
+	else
+	  /* Otherwise they must both be non-NULL.  */
+	  return k1 == k2;
+      }
+      template <typename T>
+      static inline void remove (T &)
+      {
+	/* empty; the nodes are handled elsewhere.  */
+      }
+      template <typename T>
+      static inline void mark_deleted (T &entry)
+      {
+	entry.m_key = reinterpret_cast<key_type> (1);
+      }
+      template <typename T>
+      static inline void mark_empty (T &entry)
+      {
+	entry.m_key = NULL;
+      }
+      template <typename T>
+      static inline bool is_deleted (const T &entry)
+      {
+	return entry.m_key == reinterpret_cast<key_type> (1);
+      }
+      template <typename T>
+      static inline bool is_empty (const T &entry)
+      {
+	return entry.m_key == NULL;
+      }
+      static const bool empty_zero_p = false;
+    };
+#endif
+    key_t (tree type, const program_point &point,
+	   const svalue2 *base_sval, const svalue2 *iter_sval)
+      : m_type (type), m_point (point.get_function_point ()),
+	m_base_sval (base_sval), m_iter_sval (iter_sval)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_base_sval);
+      hstate.add_ptr (m_iter_sval);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_type == other.m_type
+	      && m_point == other.m_point
+	      && m_base_sval == other.m_base_sval
+	      && m_iter_sval == other.m_iter_sval);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    tree m_type;
+#if 0
+    program_point m_point;
+#else
+    // FIXME: for now, just the function_point, as it's easier to hash this
+    function_point m_point;
+#endif
+    const svalue2 *m_base_sval;
+    const svalue2 *m_iter_sval;
+  };
+
+  enum direction_t
+    {
+     DIR_ASCENDING,
+     DIR_DESCENDING,
+     DIR_UNKNOWN
+    };
+  widening_svalue2 (tree type, const program_point &point,
+		    const svalue2 *base_sval, const svalue2 *iter_sval)
+  : svalue2 (complexity::from_pair (base_sval->get_complexity (),
+				    iter_sval->get_complexity ()),
+	     type),
+    m_point (point.get_function_point ()),
+    m_base_sval (base_sval), m_iter_sval (iter_sval)
+  {
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_WIDENING; }
+  const widening_svalue2 *dyn_cast_widening_svalue2 () const { return this; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const svalue2 *get_base_svalue2 () const { return m_base_sval; }
+  const svalue2 *get_iter_svalue2 () const { return m_iter_sval; }
+
+  enum direction_t get_direction () const;
+
+  tristate eval_condition_without_cm (enum tree_code op,
+				      tree rhs_cst) const;
+
+ private:
+#if 0
+  program_point m_point;
+#else
+  function_point m_point;
+#endif
+  const svalue2 *m_base_sval;
+  const svalue2 *m_iter_sval;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <widening_svalue2 *>::test (svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_WIDENING;
+}
+
+#if 1
+template <> struct default_hash_traits<widening_svalue2::key_t>
+: public member_function_hash_traits<widening_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+#endif
+
+namespace ana {
+
+/* Concrete subclass of svalue2 representing a mapping of bit-ranges
+   to svalues, analogous to a cluster within the store.
+
+   This is for use in places where we want to represent a store-like
+   mapping, but are required to use an svalue2, such as when handling
+   compound assignments and compound return values.
+
+   Instances of this class shouldn't be bound as-is into the store;
+   instead they should be unpacked.  Similarly, they should not be
+   nested.  */
+
+class compound_svalue2 : public svalue2
+{
+public:
+  typedef binding_map::iterator_t iterator_t;
+
+  /* A support class for uniquifying instances of compound_svalue2.
+     Note that to avoid copies, keys store pointers to binding_maps,
+     rather than the maps themselves.  */
+  struct key_t
+  {
+    key_t (tree type, const binding_map *map_ptr)
+    : m_type (type), m_map_ptr (map_ptr)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_type);
+      //hstate.add_ptr (m_map_ptr); // TODO
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_type == other.m_type
+	      && *m_map_ptr == *other.m_map_ptr);
+    }
+
+    void mark_deleted () { m_type = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_type = NULL_TREE; }
+    bool is_deleted () const { return m_type == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_type == NULL_TREE; }
+
+    tree m_type;
+    const binding_map *m_map_ptr;
+  };
+
+  compound_svalue2 (tree type, const binding_map &map)
+  : svalue2 (calc_complexity (map), type),
+    m_map (map)
+  {
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_COMPOUND; }
+  const compound_svalue2 *dyn_cast_compound_svalue2 () const { return this; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  iterator_t begin () const { return m_map.begin (); }
+  iterator_t end () const { return m_map.end (); }
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  struct key_t make_key () const
+  {
+    return key_t (get_type (), &m_map);
+  }
+
+ private:
+  static complexity calc_complexity (const binding_map &map);
+
+  binding_map m_map;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <compound_svalue2 *>::test (svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_COMPOUND;
+}
+
+template <> struct default_hash_traits<compound_svalue2::key_t>
+: public member_function_hash_traits<compound_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
+namespace ana {
+
+/* A defined value arising from a statement, where we want to identify a
+   particular unknown value, rather than resorting to the unknown_value
+   singleton, so that the value can have sm-state.
+
+   Comparisons of variables that share the same conjured_svalue2 are known
+   to be equal, even if we don't know what the value is.
+
+   For example, this is used for the values of regions that may have been
+   touched when calling an unknown function.
+
+   The value captures a region as well as a stmt in order to avoid falsely
+   aliasing the various values that could arise in one statement.  For
+   example, after:
+      unknown_fn (&a, &b);
+   we want values to clobber a and b with, but we don't want to use the
+   same value, or it would falsely implicitly assume that a == b.  */
+
+class conjured_svalue2 : public svalue2
+{
+public:
+  typedef binding_map::iterator_t iterator_t;
+
+  /* A support class for uniquifying instances of conjured_svalue2.  */
+  struct key_t
+  {
+    key_t (tree type, const gimple *stmt, const region2 *id_reg)
+    : m_type (type), m_stmt (stmt), m_id_reg (id_reg)
+    {}
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_type);
+      hstate.add_ptr (m_stmt);
+      hstate.add_ptr (m_id_reg);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_type == other.m_type
+	      && m_stmt == other.m_stmt
+	      && m_id_reg == other.m_id_reg);
+    }
+
+    /* Use m_stmt to mark empty/deleted, as m_type can be NULL for
+       legitimate instances.  */
+    void mark_deleted () { m_stmt = reinterpret_cast<const gimple *> (1); }
+    void mark_empty () { m_stmt = NULL; }
+    bool is_deleted () const
+    {
+      return m_stmt == reinterpret_cast<const gimple *> (1);
+    }
+    bool is_empty () const { return m_stmt == NULL; }
+
+    tree m_type;
+    const gimple *m_stmt;
+    const region2 *m_id_reg;
+  };
+
+  conjured_svalue2 (tree type, const gimple *stmt, const region2 *id_reg)
+  : svalue2 (complexity (id_reg), type),
+    m_stmt (stmt), m_id_reg (id_reg)
+  {
+    gcc_assert (m_stmt != NULL);
+  }
+
+  enum kind get_kind () const FINAL OVERRIDE { return SK_CONJURED; }
+  const conjured_svalue2 *dyn_cast_conjured_svalue2 () const { return this; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+#if 0
+  void dump_dot_to_pp (const region_model2 &model,
+		       pretty_printer *pp) const
+    FINAL OVERRIDE;
+#endif
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+ private:
+  const gimple *m_stmt;
+  const region2 *m_id_reg;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <conjured_svalue2 *>::test (svalue2 *sval)
+{
+  return sval->get_kind () == svalue2::SK_CONJURED;
+}
+
+#if 1
+template <> struct default_hash_traits<conjured_svalue2::key_t>
+: public member_function_hash_traits<conjured_svalue2::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+#endif
+
+namespace ana {
+
+/* Region and its subclasses.
+
+   The class hierarchy looks like this (using indentation to show
+   inheritance, and with region_kinds shown for the concrete subclasses):
+
+   FIXME: this needs a rewrite; reorganizing regions by identity, rather than
+   structure.  So e.g. a global "struct coord c;" is now a decl_region, rather
+   than a struct_region.
+
+   region
+     space_region
+       frame_region (RK_FRAME)
+       globals_region (RK_GLOBALS)
+       code_region (RK_CODE)
+       stack_region (RK_STACK)
+       heap_region (RK_HEAP)
+       root_region (RK_ROOT)
+     function_region (RK_FUNCTION)
+     label_region2 (RK_LABEL)
+     symbolic_region (RK_SYMBOLIC)
+     field_region2 (RK_FIELD)
+     element_region2 (RK_ELEMENT)
+     offset_region2 (RK_OFFSET)
+     heap_allocated_region2 (RK_HEAP_ALLOCATED)
+     alloca_region2 (RK_ALLOCA)
+     string_region2 (RK_STRING)
+     unknown_region2 (RK_UNKNOWN).  */
+
+/* Abstract base class representing a chunk of memory.
+
+   Regions form a tree-like hierarchy, with a root region at the base,
+   with memory space regions within it, representing the stack and
+   globals, with frames within the stack, and regions for variables
+   within the frames and the "globals" region.  Regions for structs
+   can have subregions for fields.
+
+   FIXME:
+   A region can optionally have a value, or inherit its value from
+   the first ancestor with a value.  For example, the stack region
+   has a "uninitialized" poison value which is inherited by all
+   descendent regions that don't themselves have a value.  */
+
+class region2
+{
+public:
+  /* An enum for discriminating between the different concrete subclasses
+     of region2.  */
+  enum kind
+  {
+   RK_FRAME,
+   RK_GLOBALS,
+   RK_CODE,
+   RK_FUNCTION,
+   RK_LABEL,
+   RK_STACK,
+   RK_HEAP,
+   RK_ROOT,
+   RK_SYMBOLIC,
+   RK_DECL,
+   RK_FIELD,
+   RK_ELEMENT,
+   RK_OFFSET,
+   RK_CAST,
+   RK_HEAP_ALLOCATED,
+   RK_ALLOCA,
+   RK_STRING,
+   RK_UNKNOWN
+  };
+  static const char *kind_to_str (enum kind);
+
+  virtual ~region2 ();
+
+  bool operator== (const region2 &other) const;
+  bool operator!= (const region2 &other) const { return !(*this == other); }
+
+  unsigned get_id () const { return m_id; }
+  static int cmp_ids (const region2 *reg1, const region2 *reg2);
+
+  virtual enum kind get_kind () const = 0;
+  virtual const frame_region2 *
+  dyn_cast_frame_region2 () const { return NULL; }
+  virtual const function_region2 *
+  dyn_cast_function_region2 () const { return NULL; }
+  virtual const symbolic_region2 *
+  dyn_cast_symbolic_region2 () const { return NULL; }
+  virtual const decl_region2 *
+  dyn_cast_decl_region2 () const { return NULL; }
+  virtual const field_region2 *
+  dyn_cast_field_region2 () const { return NULL; }
+  virtual const element_region2 *
+  dyn_cast_element_region2 () const { return NULL; }
+  virtual const offset_region2 *
+  dyn_cast_offset_region2 () const { return NULL; }
+  virtual const cast_region2 *
+  dyn_cast_cast_region2 () const { return NULL; }
+  virtual const string_region2 *
+  dyn_cast_string_region2 () const { return NULL; }
+
+  virtual void accept (visitor *v) const;
+
+  const region2 *get_parent_region () const { return m_parent; }
+  const region2 *get_base_region () const;
+  bool base_region_p () const;
+  bool descendent_of_p (const region2 *elder) const;
+  const frame_region2 *maybe_get_frame_region () const;
+
+  tree maybe_get_decl () const;
+
+#if 0
+  void set_value (region_model2 &model, region_id this_rid, svalue2_id rhs_sid,
+		  region_model2_context *ctxt);
+  svalue2_id get_value (region_model2 &model, bool non_null,
+		       region_model2_context *ctxt);
+  svalue2_id get_value_direct () const { return m_sval_id; }
+
+  svalue2_id get_inherited_child_sid (region *child,
+				     region_model2 &model,
+				     region_model2_context *ctxt);
+#endif
+
+  tree get_type () const { return m_type; }
+
+  hashval_t hash () const;
+
+  void print (const region_model2 &model,
+	      pretty_printer *pp) const;
+  label_text get_desc (bool simple=true) const;
+
+#if 0
+  virtual void dump_dot_to_pp (const region_model2 &model,
+			       pretty_printer *pp) const;
+#endif
+  void dump_to_pp (const region_model2 &model,
+		   pretty_printer *pp,
+		   const char *prefix,
+		   bool is_last_child) const;
+
+  virtual void dump_to_pp (pretty_printer *pp, bool simple) const = 0;
+  void dump (bool simple) const;
+
+#if 0
+  void add_view (region_id view_rid, region_model2 *model);
+  region_id get_view (tree type, region_model2 *model) const;
+  region_id get_active_view () const { return m_active_view_rid; }
+  bool is_view_p () const { return m_is_view; }
+#endif
+#if 0
+  virtual void validate (const region_model2 &model) const;
+#endif
+
+  bool non_null_p (const region_model2 &model) const;
+
+  static int cmp_ptrs (const void *, const void *);
+
+  region_offset get_offset () const;
+  bool get_byte_size (byte_size_t *out) const;
+  bool get_bit_size (bit_size_t *out) const;
+
+  void
+  get_subregions_for_binding (region_model2_manager *mgr,
+			      bit_offset_t start_bit_offset,
+			      bit_size_t size_in_bits,
+			      tree type,
+			      auto_vec <const region2 *> *out) const;
+
+  bool symbolic_for_unknown_ptr_p () const;
+
+  const complexity &get_complexity () const { return m_complexity; }
+
+ protected:
+  region2 (complexity c, unsigned id, const region2 *parent, tree type);
+
+  virtual void add_to_hash (inchash::hash &hstate) const;
+
+ private:
+#if 0
+  void become_active_view (region_model2 &model, region_id this_rid);
+  void deactivate_any_active_view (region_model2 &model);
+  void deactivate_view (region_model2 &model, region_id this_view_rid);
+#endif
+  region_offset calc_offset () const;
+
+  complexity m_complexity;
+  unsigned m_id; // purely for deterministic sorting at this stage, for dumps
+  const region2 *m_parent;
+  tree m_type;
+
+  mutable region_offset *m_cached_offset;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const region2 *>::test (const region2 *)
+{
+  return true;
+}
+
+namespace ana {
+
+/* Abstract subclass of region2, for regions that represent an untyped
+   space within memory, such as the stack or the heap.  */
+
+class space_region2 : public region2
+{
+protected:
+  space_region2 (unsigned id, const region2 *parent)
+  : region2 (complexity (parent), id, parent, NULL_TREE)
+  {}
+};
+
+/* Concrete space_region2 subclass, representing a function frame on the stack,
+   to contain the locals.
+   The parent is the stack region; there's also a hierarchy of call-stack
+   prefixes expressed via m_calling_frame.
+   For example, given "oldest" calling "middle" called "newest" we would have
+   - a stack depth of 3
+   - frame (A) for "oldest" with index 0 for depth 1, calling_frame == NULL
+   - frame (B) for "middle" with index 1 for depth 2, calling_frame == (A)
+   - frame (C) for "newest" with index 2 for depth 3, calling_frame == (B)
+   where the parent region for each of the frames is the "stack" region.
+   The index is the count of frames earlier than this in the stack.  */
+
+class frame_region2 : public space_region2
+{
+public:
+  frame_region2 (unsigned id, const region2 *parent,
+		 const frame_region2 *calling_frame,
+		 function *fun, int index)
+  : space_region2 (id, parent), m_calling_frame (calling_frame),
+    m_fun (fun), m_index (index)
+  {}
+  ~frame_region2 ();
+
+  /* region2 vfuncs.  */
+  enum kind get_kind () const FINAL OVERRIDE { return RK_FRAME; }
+  const frame_region2 * dyn_cast_frame_region2 () const FINAL OVERRIDE
+  {
+    return this;
+  }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+#if 0
+  void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
+#endif
+
+  /* Accessors.  */
+  const frame_region2 *get_calling_frame () const { return m_calling_frame; }
+  function *get_function () const { return m_fun; }
+  int get_index () const { return m_index; }
+  int get_stack_depth () const { return m_index + 1; }
+
+  bool compare_fields (const frame_region2 &other) const;
+
+  const region2 *get_region_for_local (region_model2_manager *mgr,
+				       tree expr) const;
+
+  unsigned get_num_locals () const { return m_locals.elements (); }
+
+ private:
+  const frame_region2 *m_calling_frame;
+  function *m_fun;
+  int m_index;
+  typedef hash_map<tree, region2 *> map_t;
+  map_t m_locals;
+  /* TODO: do we want a distinction between params (assumed initialized)
+     vs temporaries?  */
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const frame_region2 *>::test (const region2 *reg)
+{
+  return reg->get_kind () == region2::RK_FRAME;
+}
+
+namespace ana {
+
+/* Concrete space_region2 subclass, to hold global variables (data and bss).  */
+
+class globals_region2 : public space_region2
+{
+ public:
+  globals_region2 (unsigned id, const region2 *parent)
+  : space_region2 (id, parent)
+  {}
+
+  /* region2 vfuncs.  */
+  enum kind get_kind () const FINAL OVERRIDE { return RK_GLOBALS; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  bool compare_fields (const globals_region2 &other) const;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const globals_region2 *>::test (const region2 *reg)
 {
-  extern void add_path_var (path_var pv, hash &hstate);
-} // namespace inchash
-
+  return reg->get_kind () == region2::RK_GLOBALS;
+}
 
 namespace ana {
 
-/* A class for renumbering IDs within a region_model, mapping old IDs
-   to new IDs (e.g. when removing one or more elements, thus needing to
-   renumber).  */
-// TODO: could this be useful for equiv_class_ids?
+/* Concrete region2 subclass.  A map_region2 representing the code, using
+   FUNCTION_DECLs for its keys.  */
 
-template <typename T>
-class id_map
+class code_region2 : public space_region2
 {
- public:
-  id_map (int num_ids);
-  void put (T src, T dst);
-  T get_dst_for_src (T src) const;
-  T get_src_for_dst (T dst) const;
-  void dump_to_pp (pretty_printer *pp) const;
-  void dump () const;
-  void update (T *) const;
+public:
+  code_region2 (unsigned id, const region2 *parent)
+  : space_region2 (id, parent)
+  {}
 
- private:
-  auto_vec<T> m_src_to_dst;
-  auto_vec<T> m_dst_to_src;
-};
+  /* region2 vfuncs.  */
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  enum kind get_kind () const FINAL OVERRIDE { return RK_CODE; }
+
+  const region2 *get_element (region_model2 *model,
+			const svalue2 *index,
+			region_model2_context *ctxt);
 
-/* class id_map.  */
+  bool compare_fields (const code_region2 &other) const;
+};
 
-/* id_map's ctor, which populates the map with dummy null values.  */
+} // namespace ana
 
-template <typename T>
-inline id_map<T>::id_map (int num_svalues)
-: m_src_to_dst (num_svalues),
-  m_dst_to_src (num_svalues)
+template <>
+template <>
+inline bool
+is_a_helper <const code_region2 *>::test (const region2 *reg)
 {
-  for (int i = 0; i < num_svalues; i++)
-    {
-      m_src_to_dst.quick_push (T::null ());
-      m_dst_to_src.quick_push (T::null ());
-    }
+  return reg->get_kind () == region2::RK_CODE;
 }
 
-/* Record that SRC is to be mapped to DST.  */
+namespace ana {
+
+// FIXME:
+/* Concrete region2 subclass.  A region2 representing the code for
+   a particular function, using LABEL_DECLs for its keys.  */
 
-template <typename T>
-inline void
-id_map<T>::put (T src, T dst)
+class function_region2 : public region2
 {
-  m_src_to_dst[src.as_int ()] = dst;
-  m_dst_to_src[dst.as_int ()] = src;
-}
+public:
+  function_region2 (unsigned id, const code_region2 *parent, tree fndecl)
+  : region2 (complexity (parent), id, parent, TREE_TYPE (fndecl)),
+    m_fndecl (fndecl)
+  {
+    gcc_assert (FUNC_OR_METHOD_TYPE_P (TREE_TYPE (fndecl)));
+  }
+
+  /* region2 vfuncs.  */
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  enum kind get_kind () const FINAL OVERRIDE { return RK_FUNCTION; }
+  const function_region2 *
+  dyn_cast_function_region2 () const FINAL OVERRIDE{ return this; }
+
+  tree get_fndecl () const { return m_fndecl; }
+
+  region2 *get_element (region_model2 *model,
+			const svalue2 *index_sid,
+			region_model2_context *ctxt);
+
+  bool compare_fields (const function_region2 &other) const;
+
+private:
+  tree m_fndecl;
+};
 
-/* Get the new value for SRC within the map.  */
+} // namespace ana
 
-template <typename T>
-inline T
-id_map<T>::get_dst_for_src (T src) const
+template <>
+template <>
+inline bool
+is_a_helper <const function_region2 *>::test (const region2 *reg)
 {
-  if (src.null_p ())
-    return src;
-  return m_src_to_dst[src.as_int ()];
+  return reg->get_kind () == region2::RK_FUNCTION;
 }
 
-/* Given DST, a new value, determine which old value will be mapped to it
-   (the inverse of the map).  */
+namespace ana {
+
+/* Concrete region2 subclass.  A region2 representing a particular label
+   within a function.  */
+
+class label_region2 : public region2
+{
+public:
+  label_region2 (unsigned id, const function_region2 *parent, tree label)
+  : region2 (complexity (parent), id, parent, NULL_TREE), m_label (label)
+  {
+    gcc_assert (TREE_CODE (label) == LABEL_DECL);
+  }
+
+  /* region2 vfuncs.  */
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  enum kind get_kind () const FINAL OVERRIDE { return RK_LABEL; }
+
+  //bool compare_fields (const function_region2 &other) const;
+
+private:
+  tree m_label;
+};
+
+} // namespace ana
 
-template <typename T>
-inline T
-id_map<T>::get_src_for_dst (T dst) const
+template <>
+template <>
+inline bool
+is_a_helper <const label_region2 *>::test (const region2 *reg)
 {
-  if (dst.null_p ())
-    return dst;
-  return m_dst_to_src[dst.as_int ()];
+  return reg->get_kind () == region2::RK_LABEL;
 }
 
-/* Dump this id_map to PP.  */
+namespace ana {
+
+/* Concrete region2 subclass representing a stack, containing all stack
+   frames, and implicitly providing a POISON_KIND_UNINIT value to all
+   child region2s by default.  */
 
-template <typename T>
-inline void
-id_map<T>::dump_to_pp (pretty_printer *pp) const
+class stack_region2 : public region2
 {
-  pp_string (pp, "src to dst: {");
-  unsigned i;
-  T *dst;
-  FOR_EACH_VEC_ELT (m_src_to_dst, i, dst)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      T src (T::from_int (i));
-      src.print (pp);
-      pp_string (pp, " -> ");
-      dst->print (pp);
-    }
-  pp_string (pp, "}");
-  pp_newline (pp);
+public:
+  stack_region2 (unsigned id, region2 *parent)
+  : region2 (complexity (parent), id, parent, NULL_TREE)
+  {}
 
-  pp_string (pp, "dst to src: {");
-  T *src;
-  FOR_EACH_VEC_ELT (m_dst_to_src, i, src)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      T dst (T::from_int (i));
-      dst.print (pp);
-      pp_string (pp, " <- ");
-      src->print (pp);
-    }
-  pp_string (pp, "}");
-  pp_newline (pp);
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  bool compare_fields (const stack_region2 &other) const;
+
+  enum kind get_kind () const FINAL OVERRIDE { return RK_STACK; }
+
+#if 0
+  static bool can_merge_p (const stack_region2 *stack_region2_a,
+			   const stack_region2 *stack_region2_b,
+			   model_merger *merger);
+  const svalue2 *get_value_by_name (tree identifier,
+			      const region_model2 &model) const;
+#endif
+
+#if 0
+  void validate (const region_model2 &model) const FINAL OVERRIDE;
+#endif
+ private:
+#if 0
+  void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
+#endif
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const stack_region2 *>::test (const region2 *reg)
+{
+  return reg->get_kind () == region2::RK_STACK;
 }
 
-/* Dump this id_map to stderr.  */
+namespace ana {
+
+/* Concrete region2 subclass: a region2 within which region2s can be
+   dynamically allocated.  */
+
+class heap_region2 : public region2
+{
+public:
+  heap_region2 (unsigned id, region2 *parent)
+  : region2 (complexity (parent), id, parent, NULL_TREE)
+  {}
+
+#if 0
+  bool compare_fields (const heap_region2 &other) const;
+#endif
+
+  enum kind get_kind () const FINAL OVERRIDE { return RK_HEAP; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+#if 0
+  static bool can_merge_p (const heap_region2 *heap_a, region2_id heap_a_rid,
+			   const heap_region2 *heap_b, region2_id heap_b_rid,
+			   heap_region2 *merged_heap, region2_id merged_heap_rid,
+			   model_merger *merger);
+#endif
+};
+
+} // namespace ana
 
-template <typename T>
-DEBUG_FUNCTION inline void
-id_map<T>::dump () const
+template <>
+template <>
+inline bool
+is_a_helper <const heap_region2 *>::test (const region2 *reg)
 {
-  pretty_printer pp;
-  pp.buffer->stream = stderr;
-  dump_to_pp (&pp);
-  pp_flush (&pp);
+  return reg->get_kind () == region2::RK_HEAP;
 }
 
-/* Update *ID from the old value to its new value in this map.  */
+namespace ana {
+
+/* Concrete region2 subclass.  The root region2, containing all region2s
+   (either directly, or as descendents).
+   Unique within a region_model2.  */
+
+class root_region2 : public region2
+{
+public:
+  root_region2 (unsigned id);
+
+  bool compare_fields (const root_region2 &other) const;
+
+  enum kind get_kind () const FINAL OVERRIDE { return RK_ROOT; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+#if 0
+  static bool can_merge_p (const root_region2 *root_region2_a,
+			   const root_region2 *root_region2_b,
+			   root_region2 *merged_root_region2,
+			   model_merger *merger);
+#endif
 
-template <typename T>
-inline void
-id_map<T>::update (T *id) const
+  const svalue2 *get_value_by_name (tree identifier,
+			      const region_model2 &model) const;
+
+#if 0
+  void validate (const region_model2 &model) const FINAL OVERRIDE;
+#endif
+
+private:
+#if 0
+  void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
+#endif
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const root_region2 *>::test (const region2 *reg)
 {
-  *id = get_dst_for_src (*id);
+  return reg->get_kind () == region2::RK_ROOT;
 }
 
-/* Variant of the above, which only stores things in one direction.
-   (e.g. for merging, when the number of destination regions is not
-   the same of the src regions, and can grow).  */
+namespace ana {
+
+/* Concrete region2 subclass: a region2 to use when dereferencing an unknown
+   pointer.  */
 
-template <typename T>
-class one_way_id_map
+class symbolic_region2 : public region2
 {
- public:
-  one_way_id_map (int num_ids);
-  void put (T src, T dst);
-  T get_dst_for_src (T src) const;
-  void dump_to_pp (pretty_printer *pp) const;
-  void dump () const;
-  void update (T *) const;
+public:
+  symbolic_region2 (unsigned id, region2 *parent, const svalue2 *sval_ptr)
+  : region2 (complexity::from_pair (parent, sval_ptr), id, parent,
+	     TREE_TYPE (sval_ptr->get_type ())),
+    m_sval_ptr (sval_ptr)
+  {}
 
- private:
-  auto_vec<T> m_src_to_dst;
+  const symbolic_region2 *
+  dyn_cast_symbolic_region2 () const FINAL OVERRIDE { return this; }
+
+  bool compare_fields (const symbolic_region2 &other) const;
+
+  enum kind get_kind () const FINAL OVERRIDE { return region2::RK_SYMBOLIC; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const svalue2 *get_pointer () const { return m_sval_ptr; }
+
+private:
+  const svalue2 *m_sval_ptr;
 };
 
-/* class one_way_id_map.  */
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const symbolic_region2 *>::test (const region2 *reg)
+{
+  return reg->get_kind () == region2::RK_SYMBOLIC;
+}
+
+namespace ana {
+
+/* Concrete region2 subclass representing the memory occupied by a
+   variable (whether for a global or a local).  */
+
+class decl_region2 : public region2
+{
+public:
+  decl_region2 (unsigned id, const region2 *parent, tree decl)
+  : region2 (complexity (parent), id, parent, TREE_TYPE (decl)), m_decl (decl)
+  {}
+
+  bool compare_fields (const decl_region2 &other) const;
+
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_DECL; }
+  const decl_region2 *
+  dyn_cast_decl_region2 () const FINAL OVERRIDE { return this; }
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  tree get_decl () const { return m_decl; }
+  int get_stack_depth () const;
+
+protected:
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+
+private:
+  tree m_decl;
+};
 
-/* one_way_id_map's ctor, which populates the map with dummy null values.  */
+} // namespace ana
 
-template <typename T>
-inline one_way_id_map<T>::one_way_id_map (int num_svalues)
-: m_src_to_dst (num_svalues)
+template <>
+template <>
+inline bool
+is_a_helper <const decl_region2 *>::test (const region2 *reg)
 {
-  for (int i = 0; i < num_svalues; i++)
-    m_src_to_dst.quick_push (T::null ());
+  return reg->get_kind () == region2::RK_DECL;
 }
 
-/* Record that SRC is to be mapped to DST.  */
+namespace ana {
+
+/* Concrete region2 subclass representing the memory occupied by a
+   field within a struct or union.  */
+
+class field_region2 : public region2
+{
+public:
+  field_region2 (unsigned id, const region2 *parent, tree field)
+  : region2 (complexity (parent), id, parent, TREE_TYPE (field)),
+    m_field (field)
+  {}
+
+  bool compare_fields (const field_region2 &other) const;
+
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_FIELD; }
 
-template <typename T>
-inline void
-one_way_id_map<T>::put (T src, T dst)
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  const field_region2 *
+  dyn_cast_field_region2 () const FINAL OVERRIDE { return this; }
+
+  tree get_field () const { return m_field; }
+
+protected:
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+
+private:
+  tree m_field;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const field_region2 *>::test (const region2 *reg)
 {
-  m_src_to_dst[src.as_int ()] = dst;
+  return reg->get_kind () == region2::RK_FIELD;
 }
 
-/* Get the new value for SRC within the map.  */
+namespace ana {
+
+/* An element within an array.  */
+
+class element_region2 : public region2
+{
+public:
+  element_region2 (unsigned id, const region2 *parent, tree element_type,
+		   const svalue2 *index)
+  : region2 (complexity::from_pair (parent, index), id, parent, element_type),
+    m_index (index)
+  {}
+
+  bool compare_fields (const element_region2 &other) const;
+
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_ELEMENT; }
+  const element_region2 *
+  dyn_cast_element_region2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-template <typename T>
-inline T
-one_way_id_map<T>::get_dst_for_src (T src) const
+  const svalue2 *get_index () const { return m_index; }
+
+protected:
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+
+private:
+  const svalue2 *m_index;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const element_region2 *>::test (const region2 *reg)
 {
-  if (src.null_p ())
-    return src;
-  return m_src_to_dst[src.as_int ()];
+  return reg->get_kind () == region2::RK_ELEMENT;
 }
 
-/* Dump this map to PP.  */
+namespace ana {
+
+/* A byte-offset within another region, for handling pointer arithmetic
+   as a region.  */
 
-template <typename T>
-inline void
-one_way_id_map<T>::dump_to_pp (pretty_printer *pp) const
+class offset_region2 : public region2
 {
-  pp_string (pp, "src to dst: {");
-  unsigned i;
-  T *dst;
-  FOR_EACH_VEC_ELT (m_src_to_dst, i, dst)
-    {
-      if (i > 0)
-	pp_string (pp, ", ");
-      T src (T::from_int (i));
-      src.print (pp);
-      pp_string (pp, " -> ");
-      dst->print (pp);
-    }
-  pp_string (pp, "}");
-  pp_newline (pp);
+public:
+  offset_region2 (unsigned id, const region2 *parent, tree type,
+		  const svalue2 *byte_offset)
+  : region2 (complexity::from_pair (parent, byte_offset), id, parent, type),
+    m_byte_offset (byte_offset)
+  {}
+
+  bool compare_fields (const offset_region2 &other) const;
+
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_OFFSET; }
+  const offset_region2 *
+  dyn_cast_offset_region2 () const FINAL OVERRIDE { return this; }
+
+  void accept (visitor *v) const FINAL OVERRIDE;
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  const svalue2 *get_byte_offset () const { return m_byte_offset; }
+
+protected:
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+
+private:
+  const svalue2 *m_byte_offset;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const offset_region2 *>::test (const region2 *reg)
+{
+  return reg->get_kind () == region2::RK_OFFSET;
 }
 
-/* Dump this map to stderr.  */
+namespace ana {
+
+/* A region that views another region using a different type.  */
+
+class cast_region2 : public region2
+{
+public:
+  cast_region2 (unsigned id, const region2 *original_region, tree type)
+  : region2 (complexity (original_region), id,
+	     original_region->get_parent_region (), type),
+    m_original_region (original_region)
+  {}
+
+  bool compare_fields (const cast_region2 &other) const;
+
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_CAST; }
+  const cast_region2 *
+  dyn_cast_cast_region2 () const FINAL OVERRIDE { return this; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  /* FIXME: should this just be the parent region? */
+  const region2 *get_original_region () const { return m_original_region; }
+
+protected:
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
 
-template <typename T>
-DEBUG_FUNCTION inline void
-one_way_id_map<T>::dump () const
+private:
+  const region2 *m_original_region;
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const cast_region2 *>::test (const region2 *reg)
 {
-  pretty_printer pp;
-  pp.buffer->stream = stderr;
-  dump_to_pp (&pp);
-  pp_flush (&pp);
+  return reg->get_kind () == region2::RK_CAST;
 }
 
-/* Update *ID from the old value to its new value in this map.  */
+namespace ana {
+
+/* An untyped region dynamically allocated on the heap via "malloc"
+   or similar.  */
+// FIXME: ...but could be NULL
+
+class heap_allocated_region2 : public region2
+{
+public:
+  heap_allocated_region2 (unsigned id, const region2 *parent)
+  : region2 (complexity (parent), id, parent, NULL_TREE)
+  {}
+
+#if 0
+  bool compare_fields (const element_region2 &other) const;
+#endif
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_HEAP_ALLOCATED; }
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+protected:
+#if 0
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+#endif
+};
+
+/* An untyped region dynamically allocated on the stack via "alloca".  */
+
+class alloca_region2 : public region2
+{
+public:
+  alloca_region2 (unsigned id, const frame_region2 *parent)
+  : region2 (complexity (parent), id, parent, NULL_TREE)
+  {}
+
+#if 0
+  bool compare_fields (const element_region2 &other) const;
+#endif
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_ALLOCA; }
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+protected:
+#if 0
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+#endif
+};
+
+/* A region for a STRING_CST.  */
+
+class string_region2 : public region2
+{
+public:
+  string_region2 (unsigned id, const region2 *parent, tree string_cst)
+  : region2 (complexity (parent), id, parent, TREE_TYPE (string_cst)),
+    m_string_cst (string_cst)
+  {}
+
+  const string_region2 *
+  dyn_cast_string_region2 () const FINAL OVERRIDE { return this; }
+
+#if 0
+  bool compare_fields (const element_region2 &other) const;
+#endif
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_STRING; }
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+  tree get_string_cst () const { return m_string_cst; }
+
+protected:
+#if 0
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+#endif
+private:
+  tree m_string_cst;
+};
+
+} // namespace ana
 
-template <typename T>
-inline void
-one_way_id_map<T>::update (T *id) const
+template <>
+template <>
+inline bool
+is_a_helper <const string_region2 *>::test (const region2 *reg)
 {
-  *id = get_dst_for_src (*id);
+  return reg->get_kind () == region2::RK_STRING;
 }
 
-/* Various operations delete information from a region_model.
+namespace ana {
 
-   This struct tracks how many of each kind of entity were purged (e.g.
-   for selftests, and for debugging).  */
+/* An unknown region, for handling unimplemented tree codes.  */
 
-struct purge_stats
+class unknown_region2 : public region2
 {
-  purge_stats ()
-  : m_num_svalues (0),
-    m_num_regions (0),
-    m_num_equiv_classes (0),
-    m_num_constraints (0),
-    m_num_client_items (0)
+public:
+  unknown_region2 (unsigned id, const region2 *parent, tree type)
+  : region2 (complexity (parent), id, parent, type)
   {}
 
-  int m_num_svalues;
-  int m_num_regions;
-  int m_num_equiv_classes;
-  int m_num_constraints;
-  int m_num_client_items;
+#if 0
+  bool compare_fields (const element_region2 &other) const;
+#endif
+  enum region2::kind get_kind () const FINAL OVERRIDE { return RK_UNKNOWN; }
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+
+protected:
+#if 0
+  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
+#endif
+};
+
+/* A class responsible for owning and consolidating region2 and svalue2
+   instances.
+   region2 and svalue2 instances are immutable as far as clients are
+   concerned, so they are provided as "const" ptrs.  */
+
+class region_model2_manager
+{
+public:
+  region_model2_manager ();
+  ~region_model2_manager ();
+
+  /* svalue2 consolidation.  */
+  const svalue2 *get_or_create_constant_svalue2 (tree cst_expr);
+  const svalue2 *get_or_create_unknown_svalue2 (tree type);
+  const svalue2 *get_or_create_setjmp_svalue2 (const setjmp_record &r,
+					       tree type);
+  const svalue2 *get_or_create_poisoned_svalue2 (enum poison_kind kind,
+						 tree type);
+  const svalue2 *get_or_create_initial_value (const region2 *reg);
+  const svalue2 *get_ptr_svalue2 (tree ptr_type, const region2 *pointee);
+  const svalue2 *get_or_create_unaryop (tree type, enum tree_code op,
+					const svalue2 *arg);
+  const svalue2 *get_or_create_cast (tree type, const svalue2 *arg);
+  const svalue2 *get_or_create_binop (tree type,
+				      enum tree_code op,
+				      const svalue2 *arg0, const svalue2 *arg1);
+  const svalue2 *get_or_create_sub_svalue2 (tree type,
+					    const svalue2 *parent_svalue,
+					    const region2 *subregion);
+  const svalue2 *get_or_create_unmergeable (const svalue2 *arg);
+  const svalue2 *get_or_create_widening_svalue2 (tree type,
+						 const program_point &point,
+						 const svalue2 *base_svalue,
+						 const svalue2 *iter_svalue);
+  const svalue2 *get_or_create_compound_svalue2 (tree type,
+						 const binding_map &map);
+  const svalue2 *get_or_create_conjured_svalue2 (tree type, const gimple *stmt,
+						 const region2 *id_reg);
+
+  /* region2 consolidation.  */
+  const stack_region2 * get_stack_region () const { return &m_stack_region; }
+  const heap_region2 *get_heap_region () const { return &m_heap_region; }
+  const code_region2 *get_code_region () const { return &m_code_region; }
+  const globals_region2 *get_globals_region () const
+  {
+    return &m_globals_region;
+  }
+  const function_region2 *get_region_for_fndecl (tree fndecl);
+  const label_region2 *get_region_for_label (tree label);
+  const decl_region2 *get_region_for_global (tree expr);
+  const region2 *get_field_region (const region2 *parent, tree field);
+  const region2 *get_element_region (const region2 *parent,
+				     tree element_type,
+				     const svalue2 *index);
+  const region2 *get_offset_region (const region2 *parent,
+				    tree type,
+				    const svalue2 *byte_offset);
+  const region2 *get_cast_region (const region2 *original_region,
+				  tree type);
+  const frame_region2 *get_frame_region (const frame_region2 *calling_frame,
+					 function *fun);
+  const region2 *get_symbolic_region (const svalue2 *sval);
+  const string_region2 *get_region_for_string (tree string_cst);
+
+  const region2 *
+  get_region2_for_unexpected_tree_code (region_model2_context *ctxt,
+					tree t,
+					const dump_location_t &loc);
+
+  unsigned alloc_region_id () { return m_next_region_id++; }
+
+  store2_manager *get_store2_manager () { return &m_store2_mgr; }
+
+  /* Dynamically-allocated region2 instances.
+     FIXME: for now, the number of these within the analysis can grow
+     arbitrarily.  They are still owned by the manager.  */
+  const region2 *create_region_for_heap_alloc ();
+  const region2 *create_region_for_alloca (const frame_region2 *frame);
+
+  void log_stats (logger *logger, bool show_objs) const;
+
+private:
+  bool too_complex_p (const complexity &c) const;
+  bool reject_if_too_complex (svalue2 *sval);
+
+  const svalue2 *maybe_fold_unaryop (tree type, enum tree_code op,
+				     const svalue2 *arg);
+  const svalue2 *maybe_fold_binop (tree type, enum tree_code op,
+				   const svalue2 *arg0, const svalue2 *arg1);
+  const svalue2 *maybe_fold_sub_svalue2 (tree type,
+					 const svalue2 *parent_svalue,
+					 const region2 *subregion);
+
+  unsigned m_next_region_id;
+  root_region2 m_root_region;
+  stack_region2 m_stack_region;
+  heap_region2 m_heap_region;
+
+  /* svalue2 consolidation.  */
+  typedef hash_map<tree, constant_svalue2 *> constants_map_t;
+  constants_map_t m_constants_map;
+
+  typedef hash_map<tree, unknown_svalue2 *> unknowns_map_t;
+  unknowns_map_t m_unknowns_map;
+  const unknown_svalue2 *m_unknown_NULL;
+
+  typedef hash_map<poisoned_svalue2::key_t,
+		   poisoned_svalue2 *> poisoned_values_map_t;
+  poisoned_values_map_t m_poisoned_values_map;
+
+  typedef hash_map<setjmp_svalue2::key_t,
+		   setjmp_svalue2 *> setjmp_values_map_t;
+  setjmp_values_map_t m_setjmp_values_map;
+
+  typedef hash_map<const region2 *, initial_svalue2 *> initial_values_map_t;
+  initial_values_map_t m_initial_values_map;
+
+  typedef hash_map<const region2 *, region_svalue2 *> pointer_values_map_t;
+  pointer_values_map_t m_pointer_values_map;
+
+  typedef hash_map<unaryop_svalue2::key_t,
+		   unaryop_svalue2 *> unaryop_values_map_t;
+  unaryop_values_map_t m_unaryop_values_map;
+
+  typedef hash_map<binop_svalue2::key_t, binop_svalue2 *> binop_values_map_t;
+  binop_values_map_t m_binop_values_map;
+
+  typedef hash_map<sub_svalue2::key_t, sub_svalue2 *> sub_values_map_t;
+  sub_values_map_t m_sub_values_map;
+
+  typedef hash_map<const svalue2 *,
+		   unmergeable_svalue2 *> unmergeable_values_map_t;
+  unmergeable_values_map_t m_unmergeable_values_map;
+
+  typedef hash_map<widening_svalue2::key_t,
+		   widening_svalue2 */*,
+	           widening_svalue2::key_t::hash_map_traits*/>
+    widening_values_map_t;
+  widening_values_map_t m_widening_values_map;
+
+  typedef hash_map<compound_svalue2::key_t,
+		   compound_svalue2 *> compound_values_map_t;
+  compound_values_map_t m_compound_values_map;
+
+  typedef hash_map<conjured_svalue2::key_t,
+		   conjured_svalue2 *> conjured_values_map_t;
+  conjured_values_map_t m_conjured_values_map;
+
+  /* Maximum complexity of svalues that weren't rejected.  */
+  complexity m_max_complexity;
+
+  /* region2 consolidation.  */
+
+  code_region2 m_code_region;
+  typedef hash_map<tree, function_region2 *> fndecls_map_t;
+  typedef fndecls_map_t::iterator fndecls_iterator_t;
+  fndecls_map_t m_fndecls_map;
+
+  typedef hash_map<tree, label_region2 *> labels_map_t;
+  typedef labels_map_t::iterator labels_iterator_t;
+  labels_map_t m_labels_map;
+
+  globals_region2 m_globals_region;
+  typedef hash_map<tree, decl_region2 *> globals_map_t;
+  typedef globals_map_t::iterator globals_iterator_t;
+  globals_map_t m_globals_map;
+
+  uniq_manager<region2> m_fields;
+#if 0
+  struct field_key_t { region2 *m_parent; tree m_field; };
+  typedef hash_map<field_key_t, region2 *> fields_map_t;
+  fields_map_t m_fields_map;
+#endif
+  uniq_manager<region2> m_elements;
+  uniq_manager<region2> m_offset_regions;
+  uniq_manager<region2> m_cast_regions;
+  uniq_manager<frame_region2> m_frames;
+  uniq_manager<region2> m_symbolic_regions;
+
+  typedef hash_map<tree, string_region2 *> string_map_t;
+  string_map_t m_string_map;
+
+  store2_manager m_store2_mgr;
+
+  /* "Dynamically-allocated" region2 instances.
+     FIXME: for now, the number of these within the analysis can grow
+     arbitrarily.  They are still owned by the manager.  */
+  auto_delete_vec<region2> m_managed_dynamic_regions;
+};
+
+struct append_ssa_names_cb_data;
+
+/* Helper class for handling calls to functions with known behavior.
+   Implemented in region-model2-impl-calls.c.  */
+
+class call_details
+{
+public:
+  call_details (const gcall *call, region_model2 *model,
+		region_model2_context *ctxt);
+
+  region_model2_context *get_ctxt () const { return m_ctxt; }
+  tree get_lhs_type () const { return m_lhs_type; }
+  const region2 *get_lhs_region () const { return m_lhs_region; }
+
+  bool maybe_set_lhs (const svalue2 *result) const;
+
+  tree get_arg_tree (unsigned idx) const;
+  const svalue2 *get_arg_svalue2 (unsigned idx) const;
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const;
+  void dump (bool simple) const;
+
+private:
+  const gcall *m_call;
+  region_model2 *m_model;
+  region_model2_context *m_ctxt;
+  tree m_lhs_type;
+  const region2 *m_lhs_region;
+};
+
+/* A region_model2 encapsulates a representation of the state of memory, with
+   a tree of region2s, along with their associated values.
+   The representation is graph-like because values can be pointers to
+   region2s.
+   It also stores a constraint_manager, capturing relationships between
+   the values.  */
+
+class region_model2
+{
+ public:
+  region_model2 (region_model2_manager *mgr);
+  region_model2 (const region_model2 &other);
+  ~region_model2 ();
+
+#if 0//__cplusplus >= 201103
+  region_model2 (region_model2 &&other);
+#endif
+
+  region_model2 &operator= (const region_model2 &other);
+
+  bool operator== (const region_model2 &other) const;
+  bool operator!= (const region_model2 &other) const
+  {
+    return !(*this == other);
+  }
+
+  hashval_t hash () const;
+
+  void print (pretty_printer *pp) const;
+
+  void dump_dot_to_pp (pretty_printer *pp) const;
+  void dump_dot_to_file (FILE *fp) const;
+  void dump_dot (const char *path) const;
+
+  void dump_to_pp (pretty_printer *pp, bool simple, bool multiline) const;
+  void dump (FILE *fp, bool simple, bool multiline) const;
+  void dump (bool simple) const;
+  void summarize_to_pp (pretty_printer *pp, bool simple) const;
+  void summarize (bool simple) const;
+
+  void debug () const;
+
+  void validate () const;
+
+  bool on_stmt (const gimple *stmt,
+		region_model2_context *ctxt);
+  bool on_gassign (const gassign *stmt,
+		   region_model2_context *ctxt);
+  const svalue2 * get_gassign_result (const gassign *assign,
+				      region_model2_context *ctxt);
+#if 0
+  bool on_gcall (const supernode *snode,
+		 const gcall *stmt);
+#else
+  bool on_call_pre (const gcall *stmt, region_model2_context *ctxt);
+  void on_call_post (const gcall *stmt,
+		     bool unknown_side_effects,
+		     region_model2_context *ctxt);
+
+  /* Specific handling for on_call_pre.  */
+  bool impl_call_alloca (const call_details &cd);
+  void impl_call_analyzer_describe (const gcall *call,
+				    region_model2_context *ctxt);
+  void impl_call_analyzer_eval (const gcall *call,
+				region_model2_context *ctxt);
+  bool impl_call_builtin_expect (const call_details &cd);
+  bool impl_call_calloc (const call_details &cd);
+  void impl_call_free (const call_details &cd);
+  bool impl_call_malloc (const call_details &cd);
+  bool impl_call_memset (const call_details &cd);
+  bool impl_call_strlen (const call_details &cd);
+#endif
+  void handle_unrecognized_call (const gcall *call,
+				 region_model2_context *ctxt);
+  void get_reachable_svalues (svalue2_set *out,
+			      const svalue2 *extra_sval);
+  bool on_greturn (const greturn *stmt,
+		   region_model2_context *ctxt);
+  void on_setjmp (const gcall *stmt, const exploded_node *enode,
+		  region_model2_context *ctxt);
+  void on_longjmp (const gcall *longjmp_call, const gcall *setjmp_call,
+		   int setjmp_stack_depth, region_model2_context *ctxt);
+
+  void update_for_phis (const supernode *snode,
+			const cfg_superedge *last_cfg_superedge,
+			region_model2_context *ctxt);
+
+  void handle_phi (const gphi *phi,
+		   tree lhs, tree rhs, bool is_back_edge,
+		   region_model2_context *ctxt);
+
+  bool maybe_update_for_edge (const superedge &edge,
+			      const gimple *last_stmt,
+			      region_model2_context *ctxt);
+
+  const region2 *push_frame (function *fun, vec<const svalue2 *> *arg_sids,
+			     region_model2_context *ctxt);
+  const frame_region2 *get_current_frame () const { return m_current_frame; }
+  function * get_current_function () const;
+  void pop_frame (const region2 *result_dst,
+		  bool purge, purge_stats2 *stats,
+		  const svalue2 **out_result,
+		  region_model2_context *ctxt);
+  int get_stack_depth () const;
+  const frame_region2 *get_frame_at_index (int index) const;
+
+#if 0
+  void replace_svalue2 (svalue2_id sid, const svalue2 *new_sval);
+#endif
+
+  const region2 *get_lvalue (path_var pv, region_model2_context *ctxt);
+  const region2 *get_lvalue (tree expr, region_model2_context *ctxt);
+  const svalue2 *get_rvalue (path_var pv, region_model2_context *ctxt);
+  const svalue2 *get_rvalue (tree expr, region_model2_context *ctxt);
+
+#if 0
+  svalue2_id maybe_cast (tree type, svalue2_id sid, region_model2_context *ctxt);
+  svalue2_id maybe_cast_1 (tree type, svalue2_id sid);
+
+  region2_id get_field_region2 (region2_id rid, tree field,
+			      region_model2_context *ctxt);
+#endif
+
+  const region2 *deref_rvalue (const svalue2 *ptr_sval, tree ptr_tree,
+			       region_model2_context *ctxt);
+#if 0
+  const region2 *deref_rvalue (tree ptr, region_model2_context *ctxt);
+#endif
+
+  void set_value (const region2 *lhs_reg, const svalue2 *rhs_sval,
+		  region_model2_context *ctxt);
+  void set_value (tree lhs, tree rhs, region_model2_context *ctxt);
+  void clobber_region (const region2 *reg);
+  void purge_region (const region2 *reg);
+  void zero_fill_region (const region2 *reg);
+  void mark_region_as_unknown (const region2 *reg);
+
+#if 0
+  const svalue2 *set_to_new_unknown_value (const region2 *dst_reg, tree type,
+				     region_model2_context *ctxt);
+#endif
+  void copy_region (const region2 *dst_reg, const region2 *src_reg,
+		    region_model2_context *ctxt);
+  tristate eval_condition (const svalue2 *lhs,
+			   enum tree_code op,
+			   const svalue2 *rhs) const;
+  tristate eval_condition_without_cm (const svalue2 *lhs,
+				      enum tree_code op,
+				      const svalue2 *rhs) const;
+  tristate compare_initial_and_pointer (const initial_svalue2 *init,
+					const region_svalue2 *ptr) const;
+  tristate eval_condition (tree lhs,
+			   enum tree_code op,
+			   tree rhs,
+			   region_model2_context *ctxt);
+  bool add_constraint (tree lhs, enum tree_code op, tree rhs,
+		       region_model2_context *ctxt);
+#if 0
+  region2_id add_new_malloc_region2 ();
+#endif
+  const region2 *create_region_for_heap_alloc (const svalue2 *size_in_bytes);
+  const region2 *create_region_for_alloca (const svalue2 *size_in_bytes);
+
+  tree get_representative_tree (const svalue2 *sval) const;
+#if 0
+  void get_path_vars_for_svalue2 (const svalue2 *sval,
+				  auto_vec<path_var> *out) const;
+#endif
+  path_var
+  get_representative_path_var (const svalue2 *sval,
+			       hash_set <const svalue2 *> *visited) const;
+  path_var
+  get_representative_path_var (const region2 *reg,
+			       hash_set <const svalue2 *> *visited) const;
+
+#if 0
+  void purge_unused_svalue2s (purge_stats *out,
+			     region_model2_context *ctxt,
+			     svalue2_id_set *known_used_sids = NULL);
+  void purge_region2s (const region2_id_set &set,
+		      purge_stats *stats,
+		      logger *logger);
+#endif
+  /* For selftests.  */
+  constraint_manager2 *get_constraints2 ()
+  {
+    return m_constraints2;
+  }
+
+  store2 *get_store () { return &m_store; }
+  const store2 *get_store () const { return &m_store; }
+
+  region_model2_manager *get_manager () const { return m_mgr; }
+
+#if 0
+  void get_descendents (region2_id rid, region2_id_set *out,
+			region2_id exclude_rid) const;
+#endif
+
+  void unbind_region2_and_descendents (const region2 *reg,
+				       enum poison_kind pkind,
+				       purge_stats2 *stats,
+				       logger *logger);
+
+  bool can_merge_with_p (const region_model2 &other_model,
+			 const program_point &point,
+			 region_model2 *out_model) const;
+#if 0
+  svalue2_id get_value_by_name (const char *name) const;
+
+  svalue2_id convert_byte_offset_to_array_index (tree ptr_type,
+						svalue2_id offset_sid);
+
+  region2_id get_or_create_mem_ref (tree type,
+				   svalue2_id ptr_sid,
+				   svalue2_id offset_sid,
+				   region_model2_context *ctxt);
+  region2_id get_or_create_pointer_plus_expr (tree type,
+					     svalue2_id ptr_sid,
+					     svalue2_id offset_sid,
+					     region_model2_context *ctxt);
+  region2_id get_or_create_view (region2_id raw_rid, tree type,
+				region_model2_context *ctxt);
+#endif
+  tree get_fndecl_for_call (const gcall *call,
+			    region_model2_context *ctxt);
+
+  void get_ssa_name_regions_for_current_frame
+    (auto_vec<const decl_region2 *> *out) const;
+  static void append_ssa_names_cb (const region2 *base_reg,
+				   struct append_ssa_names_cb_data *data);
+
+  const svalue2 *get_store_value (const region2 *reg) const;
+
+  bool region_exists_p (const region2 *reg) const;
+
+  void canonicalize ();
+  bool canonicalized_p () const;
+
+  void loop_replay_hack (const region_model2 *dst_state);
+
+private:
+  const region2 *get_lvalue_1 (path_var pv,
+			       region_model2_context *ctxt);
+  const svalue2 *get_rvalue_1 (path_var pv,
+			       region_model2_context *ctxt);
+
+#if 0
+  void copy_struct_region2 (region2_id dst_rid, struct_region2 *dst_reg,
+			   struct_region2 *src_reg, region_model2_context *ctxt);
+  void copy_union_region2 (region2_id dst_rid, union_region2 *src_reg,
+			  region_model2_context *ctxt);
+  void copy_array_region2 (region2_id dst_rid, array_region2 *dst_reg,
+			  array_region2 *src_reg, region_model2_context *ctxt);
+#endif
+  void add_any_constraints_from_ssa_def_stmt (tree lhs,
+					      enum tree_code op,
+					      tree rhs,
+					      region_model2_context *ctxt);
+  void add_any_constraints_from_gassign (enum tree_code op,
+					 tree rhs,
+					 const gassign *assign,
+					 region_model2_context *ctxt);
+  void add_any_constraints_from_gcall (enum tree_code op,
+				       tree rhs,
+				       const gcall *call,
+				       region_model2_context *ctxt);
+
+  void update_for_call_superedge (const call_superedge &call_edge,
+				  region_model2_context *ctxt);
+  void update_for_return_superedge (const return_superedge &return_edge,
+				    region_model2_context *ctxt);
+  void update_for_call_summary (const callgraph_superedge &cg_sedge,
+				region_model2_context *ctxt);
+  bool apply_constraints_for_gcond (const cfg_superedge &edge,
+				    const gcond *cond_stmt,
+				    region_model2_context *ctxt);
+  bool apply_constraints_for_gswitch (const switch_cfg_superedge &edge,
+				      const gswitch *switch_stmt,
+				      region_model2_context *ctxt);
+
+  int poison_any_pointers_to_descendents (const region2 *reg,
+					  enum poison_kind pkind);
+
+#if 0
+  void dump_summary_of_rep_path_vars (pretty_printer *pp,
+				      auto_vec<path_var> *rep_path_vars,
+				      bool *is_first);
+#endif
+  void on_top_level_param (tree param, region_model2_context *ctxt);
+
+  void record_dynamic_extents (const region2 *reg,
+			       const svalue2 *size_in_bytes);
+
+  /* Storing this here to avoid passing it around everywhere.  */
+  region_model2_manager *const m_mgr;
+
+  store2 m_store;
+
+  constraint_manager2 *m_constraints2; // TODO: embed, rather than dynalloc?
+
+  const frame_region2 *m_current_frame;
+};
+
+/* Some region_model2 activity could lead to warnings (e.g. attempts to use an
+   uninitialized value).  This abstract base class encapsulates an interface
+   for the region2 model to use when emitting such warnings.
+
+   It also provides an interface for being notified about svalue2_ids being
+   remapped, and being deleted.
+
+   Having this as an abstract base class allows us to support the various
+   operations needed by program_state in the analyzer within region_model2,
+   whilst keeping them somewhat modularized.  */
+
+class region_model2_context
+{
+ public:
+  virtual void warn (pending_diagnostic *d) = 0;
+
+#if 0
+  /* Return true if if's OK to purge SID when simplifying state.
+     Subclasses can return false for values that have sm state,
+     to avoid generating "leak" false positives.  */
+  virtual bool can_purge_p (svalue2_id sid) = 0;
+#endif
+
+  // FIXME:
+  /* Hook for clients to be notified when a range of SIDs have
+     been purged, so that they can purge state relating to those
+     values (and potentially emit warnings about leaks).
+     All SIDs from FIRST_PURGED_SID numerically upwards are being
+     purged.
+     The return values is a count of how many items of data the client
+     has purged (potentially for use in selftests).
+     MAP has already been applied to the IDs, but is provided in case
+     the client needs to figure out the old IDs.  */
+  virtual void on_svalue2_leak (const svalue2 *sval) = 0;
+
+  /* Hook for clients to be notified when the set of explicitly live
+     svalue2s changes, so that they can purge state relating to dead
+     svalues.  */
+  virtual void
+  on_liveness_change (const svalue2_set &live_svalues,
+		      const region_model2 *model) = 0;
+
+  virtual logger *get_logger () = 0;
+
+#if 0
+  /* Hook for clients to be notified when CHILD_SID is created
+     from PARENT_SID, when "inheriting" a value for a region2 from a
+     parent region2.
+     This exists so that state machines that inherit state can
+     propagate the state from parent to child.  */
+  virtual void on_inherited_svalue2 (svalue2_id parent_sid,
+				    svalue2_id child_sid) = 0;
+
+  /* Hook for clients to be notified when DST_SID is created
+     (or reused) as a cast from SRC_SID.
+     This exists so that state machines can propagate the state
+     from SRC_SID to DST_SID.  */
+  virtual void on_cast (svalue2_id src_sid,
+			svalue2_id dst_sid) = 0;
+#endif
+  /* Hook for clients to be notified when the condition
+     "LHS OP RHS" is added to the region2 model.
+     This exists so that state machines can detect tests on edges,
+     and use them to trigger sm-state transitions (e.g. transitions due
+     to ptrs becoming known to be NULL or non-NULL, rather than just
+     "unchecked") */
+  virtual void on_condition (tree lhs, enum tree_code op, tree rhs) = 0;
+
+  // FIXME:
+  /* Hooks for clients to be notified when an unknown change happens
+     to BASE_REG (in response to a call to an unknown function).  */
+  virtual void on_unknown_change (const svalue2 *sval, bool is_mutable) = 0;
+
+  /* Hooks for clients to be notified when a phi node is handled,
+     where RHS is the pertinent argument.  */
+  virtual void on_phi (const gphi *phi, tree rhs) = 0;
+
+  /* Hooks for clients to be notified when the region2 model doesn't
+     know how to handle the tree code of T at LOC.  */
+  virtual void on_unexpected_tree_code (tree t,
+					const dump_location_t &loc) = 0;
+};
+
+/* A "do nothing" subclass of region_model2_context.  */
+
+class noop_region_model2_context : public region_model2_context
+{
+public:
+  void warn (pending_diagnostic *) OVERRIDE {}
+  void on_svalue2_leak (const svalue2 *) OVERRIDE {}
+  void on_liveness_change (const svalue2_set &,
+			   const region_model2 *) OVERRIDE {}
+  logger *get_logger () OVERRIDE { return NULL; }
+#if 0
+  void on_inherited_svalue2 (svalue2_id parent_sid ATTRIBUTE_UNUSED,
+			    svalue2_id child_sid  ATTRIBUTE_UNUSED)
+    OVERRIDE
+  {
+  }
+  void on_cast (svalue2_id src_sid ATTRIBUTE_UNUSED,
+		svalue2_id dst_sid ATTRIBUTE_UNUSED) OVERRIDE
+  {
+  }
+#endif
+  void on_condition (tree lhs ATTRIBUTE_UNUSED,
+		     enum tree_code op ATTRIBUTE_UNUSED,
+		     tree rhs ATTRIBUTE_UNUSED) OVERRIDE
+  {
+  }
+  void on_unknown_change (const svalue2 *sval ATTRIBUTE_UNUSED,
+			  bool is_mutable ATTRIBUTE_UNUSED) OVERRIDE
+  {
+  }
+  void on_phi (const gphi *phi ATTRIBUTE_UNUSED,
+	       tree rhs ATTRIBUTE_UNUSED) OVERRIDE
+  {
+  }
+  void on_unexpected_tree_code (tree, const dump_location_t &) OVERRIDE {}
+};
+
+/* A subclass of region_model2_context for determining if operations fail
+   e.g. "can we generate a region2 for the lvalue of EXPR?".  */
+
+class tentative_region_model2_context : public noop_region_model2_context
+{
+public:
+  tentative_region_model2_context () : m_num_unexpected_codes (0) {}
+
+  void on_unexpected_tree_code (tree, const dump_location_t &)
+    FINAL OVERRIDE
+  {
+    m_num_unexpected_codes++;
+  }
+
+  bool had_errors_p () const { return m_num_unexpected_codes > 0; }
+
+private:
+  int m_num_unexpected_codes;
+};
+
+/* A bundle of data for use when attempting to merge two region_model2
+   instances to make a third.  */
+
+struct model2_merger
+{
+  model2_merger (const region_model2 *model_a,
+		 const region_model2 *model_b,
+		 const program_point &point,
+		 region_model2 *merged_model)
+  : m_model_a (model_a), m_model_b (model_b),
+    m_point (point),
+    m_merged_model (merged_model)
+  {
+  }
+
+  void dump_to_pp (pretty_printer *pp, bool simple) const;
+  void dump (FILE *fp, bool simple) const;
+  void dump (bool simple) const;
+
+#if ITERATED_BINOPS
+  void add_iterating_widening_binop_thing (const binop_svalue2 *binop_sval);
+#endif
+  region_model2_manager *get_manager () const
+  {
+    return m_model_a->get_manager ();
+  }
+
+#if 0
+  template <typename Subclass>
+  Subclass *get_region2_a (region2_id rid_a) const
+  {
+    return m_model_a->get_region2 <Subclass> (rid_a);
+  }
+
+  template <typename Subclass>
+  Subclass *get_region2_b (region2_id rid_b) const
+  {
+    return m_model_b->get_region2 <Subclass> (rid_b);
+  }
+
+  bool can_merge_values_p (svalue2_id sid_a,
+			   svalue2_id sid_b,
+			   svalue2_id *merged_sid);
+
+  void record_region2s (region2_id a_rid,
+		       region2_id b_rid,
+		       region2_id merged_rid);
+
+  void record_svalue2s (svalue2_id a_sid,
+		       svalue2_id b_sid,
+		       svalue2_id merged_sid);
+#endif
+
+  const region_model2 *m_model_a;
+  const region_model2 *m_model_b;
+  const program_point &m_point;
+  region_model2 *m_merged_model;
+#if ITERATED_BINOPS
+  /* FIXME: comment for this.  */
+  auto_vec<const binop_svalue2 *> m_iterated_binops;
+#endif
+};
+
+/* FIXME.  */
+
+class engine2
+{
+public:
+  region_model2_manager *get_model_manager () { return &m_mgr; }
+
+  void log_stats (logger *logger) const;
+
+private:
+  region_model2_manager m_mgr;
+
 };
 
 } // namespace ana
 
+extern void debug (const region_model2 &rmodel);
+
 namespace ana {
 
 #if CHECKING_P
